import processing.serial.*;

Serial myPort;

int inByte = 0;

int byte1 = 0;
int byte2 = 0;
int byte3 = 0;
int byte4 = 0;

float filt = 0.0;
float eps = 0.75;

boolean ready = false;
int valcount = 0;

void setup() {
  size(640, 640);
  String portName = "/dev/tty.usbserial-FTG5I76D";
  myPort = new Serial(this, portName, 9600);
}
 
void draw() {
  background(map(filt, 2800, 5600, 0, 255));
}
 
void serialEvent(Serial p) {  
  inByte = myPort.read();
  
  byte1 = byte2;
  byte2 = byte3;
  byte3 = byte4;
  byte4 = inByte;
  
  //print ("byte1: " + byte1 + " byte2: " + byte2 + " byte3: " + byte3 + " byte4: " + byte4 + "\n");  
  
  if (ready == false) {    
    if (byte1 == 1 && byte2 == 2 && byte3 == 3 && byte4 == 4) {
      ready = true;
    }
  } else {
    valcount++;
    
    if (valcount == 4) {
      int up_value = (256 * byte2) + byte1;
      int down_value = (256 * byte4) + byte3;
      int value = (up_value - down_value);
      filt = ((1-eps) * filt) + (eps * value);
      
      print("sensor: " + filt + "\n");
      
      ready = false;
      valcount = 0;
    }    
  }
  
}
